(globalThis["webpackChunkwebpack"] = globalThis["webpackChunkwebpack"] || []).push([[583],{

/***/ 56989:
/***/ ((__unused_webpack_module, __webpack_exports__, __webpack_require__) => {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony export */ __webpack_require__.d(__webpack_exports__, {
/* harmony export */   Connection: () => (/* binding */ Connection),
/* harmony export */   buildConnectionForCheckingAvailability: () => (/* binding */ buildConnectionForCheckingAvailability),
/* harmony export */   "default": () => (__WEBPACK_DEFAULT_EXPORT__)
/* harmony export */ });
/* harmony import */ var _babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(56666);
/* harmony import */ var debug__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(34386);
/* harmony import */ var debug__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(debug__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var socket_io_client__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(17768);
/* harmony import */ var socket_io_client__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(socket_io_client__WEBPACK_IMPORTED_MODULE_1__);



const debug = debug__WEBPACK_IMPORTED_MODULE_0___default()('calypso:happychat:connection');
const buildConnection = socket => typeof socket === 'string' ? new (socket_io_client__WEBPACK_IMPORTED_MODULE_1___default())(socket, {
  // force websocket connection since we no longer have sticky connections server side.
  transports: ['websocket']
}) // If socket is an URL, connect to server.
: socket; // If socket is not an url, use it directly. Useful for testing.

//The second one is an identity function, used in 'use-happychat-available' hook
class Connection {
  constructor() {
    let props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    let closeAfterAccept = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveAccept", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveConnect", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveDisconnect", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveError", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveInit", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveLocalizedSupport", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveMessage", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveHappychatEnv", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveMessageOptimistic", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveMessageUpdate", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveReconnecting", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveStatus", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveToken", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "receiveUnauthorized", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "requestTranscript", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "closeAfterAccept", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "dispatch", void 0);
    (0,_babel_runtime_helpers_defineProperty__WEBPACK_IMPORTED_MODULE_2__/* ["default"] */ .Z)(this, "openSocket", void 0);
    Object.assign(this, props);
    this.closeAfterAccept = closeAfterAccept;
  }

  /**
   * Init the SocketIO connection: check user authorization and bind socket events
   *
   * @param originalDispatch Redux dispatch function
   * @param auth Authentication promise, will return the user info upon fulfillment
   * @returns Fulfilled (returns the opened socket)
   *                   	 or rejected (returns an error message)
   */
  init(originalDispatch, auth) {
    if (this.openSocket) {
      debug('socket is already connected');
      return this.openSocket;
    }
    const dispatch = action => {
      if (action) {
        return originalDispatch(action);
      }
    };
    this.dispatch = dispatch;
    this.openSocket = new Promise((resolve, reject) => {
      auth.then(_ref => {
        let {
          url,
          user: {
            signer_user_id,
            jwt,
            groups,
            skills,
            geoLocation
          }
        } = _ref;
        // not so clean way to check if the happychat URL is staging or prod one.
        if (typeof url === 'string') {
          if (url.includes('staging')) {
            dispatch(this.receiveHappychatEnv?.('staging'));
          } else {
            dispatch(this.receiveHappychatEnv?.('production'));
          }
        }
        const socket = buildConnection(url);
        return socket.once('connect', () => dispatch(this.receiveConnect?.())).on('token', handler => {
          dispatch(this.receiveToken?.());
          handler({
            signer_user_id,
            jwt,
            groups,
            skills
          });
        }).on('init', () => {
          dispatch(this.receiveInit?.({
            signer_user_id,
            groups,
            skills,
            geoLocation
          }));
          dispatch(this.requestTranscript?.());
          resolve(socket);
        }).on('unauthorized', () => {
          socket.close();
          dispatch(this.receiveUnauthorized?.('User is not authorized'));
          reject('user is not authorized');
        }).on('disconnect', reason => dispatch(this.receiveDisconnect?.(reason))).on('reconnecting', () => dispatch(this.receiveReconnecting?.())).on('status', status => dispatch(this.receiveStatus?.(status))).on('accept', accept => {
          dispatch(this.receiveAccept?.(accept));
          if (this.closeAfterAccept) {
            socket.close();
          }
        }).on('localized-support', accept => dispatch(this.receiveLocalizedSupport?.(accept))).on('message', message => dispatch(this.receiveMessage?.(message))).on('message.optimistic', message => dispatch(this.receiveMessageOptimistic?.(message))).on('message.update', message => dispatch(this.receiveMessageUpdate?.(message))).on('reconnect_attempt', () => {
          socket.io.opts.transports = ['polling', 'websocket'];
        });
      }).catch(e => reject(e));
    });
    return this.openSocket;
  }

  /**
   * Given a Redux action, emits a SocketIO event.
   *
   * @param  {Object} action A Redux action with props
   *                  	{
   *                  		event: SocketIO event name,
   *                  		payload: contents to be sent,
   *                  		error: message to be shown should the event fails to be sent,
   *                  	}
   * @returns {Promise|undefined} Fulfilled (returns nothing) or rejected
   *                              (returns an error message)
   */
  send(action) {
    if (!this.openSocket) {
      return;
    }
    return this.openSocket.then(socket => socket.emit(action.event, action.payload), e => {
      this.dispatch?.(this.receiveError?.('failed to send ' + action.event + ': ' + e));
      // so we can relay the error message, for testing purposes
      return Promise.reject(e);
    });
  }

  /**
   *
   * Given a Redux action and a timeout, emits a SocketIO event that request
   * some info to the Happychat server.
   *
   * The request can have three states, and will dispatch an action accordingly:
   *
   * - request was succesful: would dispatch action.callback
   * - request was unsucessful: would dispatch receiveError
   *
   * @param  {Object} action A Redux action with props
   *                  	{
   *                  		event: SocketIO event name,
   *                  		payload: contents to be sent,
   *                  		callback: a Redux action creator
   *                  	}
   * @param  {number} timeout How long (in milliseconds) has the server to respond
   * @returns {Promise|undefined} Fulfilled (returns the transcript response)
   *                              or rejected (returns an error message)
   */
  request(action, timeout) {
    if (!this.openSocket) {
      return;
    }
    return this.openSocket.then(socket => {
      const promiseRace = Promise.race([new Promise((resolve, reject) => {
        socket.emit(action.event, action.payload, (e, result) => {
          if (e) {
            return reject(new Error(e)); // request failed
          }

          return resolve(result); // request succesful
        });
      }), new Promise((resolve, reject) => setTimeout(() => {
        return reject(new Error('timeout')); // request timeout
      }, timeout))]);

      // dispatch the request state upon promise race resolution
      promiseRace.then(result => this.dispatch?.(action.callback?.(result)), e => {
        if (e.message !== 'timeout') {
          this.dispatch?.(this.receiveError?.(action.event + ' request failed: ' + e.message));
        }
      });
      return promiseRace;
    }, e => {
      this.dispatch?.(this.receiveError?.('failed to send ' + action.event + ': ' + e));
      // so we can relay the error message, for testing purposes
      return Promise.reject(e);
    });
  }
}

// Used by the Help Center, it closes the socket after receiving 'accept' or 'unauthorized'
const buildConnectionForCheckingAvailability = connectionProps => new Connection(connectionProps, false);
/* harmony default export */ const __WEBPACK_DEFAULT_EXPORT__ = (connectionProps => new Connection(connectionProps));

/***/ }),

/***/ 18864:
/***/ (() => {

/* (ignored) */

/***/ })

}]);